{$APPTYPE CONSOLE}
{$Q+,R+}

program cube_checker;
uses
  SysUtils;
const
  maxN = 100;
var
  a: array[1..maxN, 1..maxN, 1..maxN] of integer;
  vxy, vyz, vxz: array[1..maxN, 1..maxN, 1..maxN] of boolean;
  n: integer;
  x: integer;
  i, j, k: integer;
  fin, fout: text;

  procedure Ex(const s: string; ec: integer);
  begin
    write(s);
    try
      close(fin); close(fout);
    except
    end;
    halt(ec);
  end;

begin
  try
    assign(fin, ParamStr(1)); reset(fin);
  except on e: Exception do
    Ex('Error opening input: ' + e.Message, 3);
  end;
  try
    read(fin, n);
  except
    Ex('Bad input file', 3);
  end;
  if ((n < 1) or (n > maxN)) then
    Ex('Bad value of N', 3);

  try
    assign(fout, ParamStr(2)); reset(fout);
  except on e: Exception do
    Ex('Can''t open output: ' + e.Message, 2);
  end;
  FillChar(vxy, SizeOf(vxy), 0);
  FillChar(vyz, SizeOf(vyz), 0);
  FillChar(vxz, SizeOf(vxz), 0);
  for k := 1 to n do
  begin
    for j := 1 to n do
    begin
      for i := 1 to n do
      begin
        if SeekEof(fout) then
          Ex('Unexpected end of file', 2);
        try
          read(fout, x);
        except
          Ex('Error when reading a number from the output', 2);
        end;
        if (x < 1) or (x > n) then
          Ex('The number isn''t in the range 1..N', 1);
        a[i, j, k] := x;
        if vxy[i, j, x] then
          Ex('Colors aren''t different (x = ' + IntToStr(i) + ')', 1);
        if vyz[j, k, x] then
          Ex('Colors aren''t different (y = ' + IntToStr(j) + ')', 1);
        if vxz[i, k, x] then
          Ex('Colors aren''t different (z = ' + IntToStr(k) + ')', 1);
        vxy[i, j, x] := true;
        vyz[j, k, x] := true;
        vxz[i, k, x] := true;
      end;
    end;
  end;
  Ex('OK', 0);
end.
